//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "CheckBoxReg.h"
#pragma package(smart_init)

#define MODIFIEDCOLOR clRed
//CheckBoxReg class definitions Written by TiANWEi 2002/09
//#include <stdlib.h>
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TCheckBoxReg *)
{
    new TCheckBoxReg(NULL);
}
//---------------------------------------------------------------------------
__fastcall TCheckBoxReg::TCheckBoxReg(TComponent* Owner)
    : TCheckBox(Owner)
{
}
//---------------------------------------------------------------------------
namespace Checkboxreg
{
    void __fastcall PACKAGE Register()
    {
        TComponentClass classes[1] = {__classid(TCheckBoxReg)};
        RegisterComponents("Samples", classes, 0);
    }
}
//---------------------------------------------------------------------------
void __fastcall TCheckBoxReg::Click()
{
    //TFontStyles FntBold;
    //char s[20];
    //TCheckBox *cb =dynamic_cast<TCheckBox *>(Sender);

    TCheckBox::Click();
    FCurrentCBR=NULL;
    if(bGotValue)
    {
        //ShowMessage("another");
        switch(FRegType)
        {
        case B_INARY:
        case D_WORD:
        if(FRegDW_read==((this->State==cbChecked)?FRegDW_unchecked:FRegDW_checked))
        {
            this->Font->Color=MODIFIEDCOLOR;       // FntBold<<fsBold;         //cb->Font->Style=FntBold;
            if(FSButton1!=NULL)
                FSButton1->Increase(1);
            if(FSButton2!=NULL)
                FSButton2->Increase(1);
            //FCurrentCount++;
        }
        else
        {
            this->Font->Color=clWindowText;       //FntBold>>fsBold;       //cb->Font->Style=FntBold;
            if(FSButton1!=NULL)
                FSButton1->Increase(-1);
            if(FSButton2!=NULL)
                FSButton2->Increase(-1);
            //(FCurrentCount>0)?(FCurrentCount--):(FCurrentCount=0);
        }
        break;
        case S_TRING:
        if(FRegSTR_read==((this->State==cbChecked)?FRegSTR_unchecked:FRegSTR_checked))
        {
            this->Font->Color=MODIFIEDCOLOR;       // FntBold<<fsBold;         //cb->Font->Style=FntBold;
            if(FSButton1!=NULL)
                FSButton1->Increase(1);
            if(FSButton2!=NULL)
                FSButton2->Increase(1);
            //FCurrentCount++;
        }
        else
        {
            this->Font->Color=clWindowText;       //FntBold>>fsBold;       //cb->Font->Style=FntBold;
            if(FSButton1!=NULL)
                FSButton1->Increase(-1);
            if(FSButton2!=NULL)
                FSButton2->Increase(-1);
            //(FCurrentCount>0)?(FCurrentCount--):(FCurrentCount=0);
        }
        }
        FColor=this->Font->Color;
        //ShowMessage(this->Owner->Name);
        //if(bNeedEnableButton)
        {
            if(FSButton1!=NULL)
            {
                //FSButton1->Enabled=true;
                //FSButton1->Enabled=(FCurrentCount>0)?true:false;
                FSButton1->EnableDisable();
            }
            if(FSButton2!=NULL)
            {
                //FSButton2->Enabled=true;
                //FSButton2->Enabled=(FCurrentCount>0)?true:false;
                FSButton2->EnableDisable();
            }
        }
    }
}
//Override default loaded!
void __fastcall TCheckBoxReg::Loaded()
{
    /*
    Some stupid but still useful thoughts in following codes,
    I now use Static member and function instead!
    int i;

    if(bNeedEnableButton&&FSButton1==NULL&&FSButton2==NULL&&bNeedShowText)
    {
       for(i=0;i<this->Owner->ComponentCount;i++)
        {
            if(this->Owner->Components[i]->ClassNameIs("TRegSpeedButton"))
            {
               if(this->Owner->Components[i]->Name.UpperCase()==("SBUTTONOK"))
                    FSButton1=(TRegSpeedButton*)(this->Owner->Components[i]);
               if(this->Owner->Components[i]->Name.UpperCase()==("SBUTTONAPPLY"))
                    FSButton2=(TRegSpeedButton*)(this->Owner->Components[i]);
            }
            if(this->Owner->Components[i]->ClassNameIs("TRichEdit"))
            {
                if(this->Owner->Components[i]->Name.UpperCase()==("EDITTEXT"))
                    FEdit=(TRichEdit*)(this->Owner->Components[i]);
            }


        }
        if(FSButton1==NULL&&FSButton2==NULL)
            bNeedEnableButton=false;
        else
            bNeedEnableButton=true;
        if(FEdit==NULL)
            bNeedShowText=false;
    }
    //*/
    TCheckBox::Loaded();
    this->Cursor=crHandPoint;
    //this->ShowHint=true;
    this->GetRegValue();
}

//Function to Set Root Key of current Tregistry obj
void __fastcall TCheckBoxReg::SetRootKey(TRegistry* reg)
{
    switch(FRegRoot)
    {
        case HKLM:
             reg->RootKey=HKEY_LOCAL_MACHINE;
             break;
        case HKUS:
             reg->RootKey=HKEY_USERS;
             break;
        case HKCU:
             reg->RootKey=HKEY_CURRENT_USER;
             break;
        case HKCL:
             reg->RootKey=HKEY_CLASSES_ROOT;
             break;
    }
    return;
}
//Read reg values
void __fastcall TCheckBoxReg::GetRegValue()
{
    TRegistry* Reg=new TRegistry();
    this->Enabled=true;
    this->Checked=false;
    this->SetRootKey(Reg);

    try
    {
    if(!FRegKeyName.IsEmpty())
    {
        if(!Reg->OpenKey(FRegKeyName,false))
        {
            //ShowMessage("Error open RegKey!"+FRegKeyName);
            //this->Enabled=false;
            FRegDW_read=FRegDW_default;
            FRegSTR_read=FRegSTR_default;
            bGotValue=true;
        }
        else
        {
            //ShowMessage("Open OK!");
            if(!FRegValueName.IsEmpty())
            {
                if(Reg->ValueExists(FRegValueName))
                {
                    //ShowMessage("Open :"+FRegValueName);
                    switch(FRegType)
                    {
                        case B_INARY:
                        Reg->ReadBinaryData(FRegValueName,&FRegDW_read,4);
                        break;
                        case D_WORD:
                        FRegDW_read=Reg->ReadInteger(FRegValueName);
                        break;
                        case S_TRING:
                        FRegSTR_read=(Reg->ReadString(FRegValueName)).UpperCase();
                    }
                }
                else
                {
                    FRegDW_read=FRegDW_default;
                    FRegSTR_read=FRegSTR_default;
                }
                switch(FRegType)
                {
                    case B_INARY:
                    case D_WORD:
                        if(FRegDW_read==FRegDW_checked)
                            this->State=cbChecked;
                        else
                        {
                            FRegDW_read=FRegDW_unchecked;
                            this->State=cbUnchecked;
                        }
                        break;
                    case S_TRING:
                        if(FRegSTR_read==FRegSTR_checked.UpperCase())
                            this->State=cbChecked;
                        else
                        {
                            //if(FRegSTR_read==FRegSTR_unchecked.UpperCase())
                            FRegSTR_read=FRegSTR_unchecked;
                            this->State=cbUnchecked;
                            //else
                            //    this->Enabled=false;
                        }
                }
                bGotValue=true;
            }
            Reg->CloseKey();
        }
    }
    }//end try
    catch(ERegistryException &E)
    {
        //ShowMessage(E.Message);
        this->Enabled=false;
        delete Reg;
        return;
    }
    delete Reg;
}
//Is value changed by the user click?
bool __fastcall TCheckBoxReg::ValueChanged()
{
    switch(FRegType)
    {
        case B_INARY:
        case D_WORD:
        return (FRegDW_read!=((this->Checked)?FRegDW_checked:FRegDW_unchecked));
        case S_TRING:
        return (FRegSTR_read!=((this->Checked)?FRegSTR_checked.UpperCase():FRegSTR_unchecked.UpperCase()));
    }
    return false;
}
//Write to registry
void __fastcall TCheckBoxReg::SetRegValue()
{
    int value;
    System::AnsiString svalue;
    TRegistry* Reg=new TRegistry();
    if(this->ValueChanged())
    {
        //ShowMessage("writing!"+this->FRegValueName);
        this->SetRootKey(Reg);
        try
        {
            //ShowMessage("Error open RegKey for writing!");
        if(Reg->OpenKey(FRegKeyName,true))
        {
            switch(FRegType)
            {
                //I use regDW_read for both Binary and DWord
                //do not set _default value to either  _checked or _unchecked
                //If you are not sure that the value are safe to delete!
                case B_INARY:
                value=(this->Checked)?FRegDW_checked:FRegDW_unchecked;
                if(value!=FRegDW_default)
                    Reg->WriteBinaryData(FRegValueName,&value,4);
                else
                {
                    //delete the value to avoid HKLM override HKCU ,eg.
                    //if(this->FRegNotSafeToDel)
                    //    Reg->WriteBinaryData(FRegValueName,&value,4);
                    //else
                    {
                        if(!Reg->DeleteValue(FRegValueName))
                            Reg->WriteBinaryData(FRegValueName,&value,4); //write to if  fail to delete
                    }



                }
                FRegDW_read=value;
                break;
                case D_WORD:
                value=(this->Checked)?FRegDW_checked:FRegDW_unchecked;
                if(value!=FRegDW_default)
                    Reg->WriteInteger(FRegValueName,value);
                else
                {
                    //delete the value to avoid HKLM override HKCU ,eg.
                    //if(this->FRegNotSafeToDel)
                    //    Reg->WriteInteger(FRegValueName,value);
                    //else
                    {
                        if(!Reg->DeleteValue(FRegValueName))
                            Reg->WriteInteger(FRegValueName,value); //write to if  fail to delete
                    }
                }

                FRegDW_read=value;
                break;
                case S_TRING:
                svalue=(this->Checked)?FRegSTR_checked:FRegSTR_unchecked;
                if(svalue!=FRegSTR_default)
                    Reg->WriteString(FRegValueName,svalue);
                else
                {
                    //delete the value to avoid HKLM override HKCU ,eg.
                    //if(this->FRegNotSafeToDel)
                    //    Reg->WriteString(FRegValueName,svalue);
                    //else
                    {
                        if(!Reg->DeleteValue(FRegValueName))
                            Reg->WriteString(FRegValueName,svalue);
                    }
                }

                FRegSTR_read=svalue;
            }
            this->Font->Color=clWindowText;
            if(FSButton1!=NULL)
                FSButton1->Increase(-1);
            if(FSButton2!=NULL)
                FSButton2->Increase(-1);
           //(FCurrentCount>0)?(FCurrentCount--):(FCurrentCount=0);
        }
        else
        {
            this->Enabled=false;
        }

        }//end try
        catch(ERegistryException &E)
        {
            ShowMessage(E.Message);
            this->Enabled=false;
            delete Reg;
            return;
        }
    }
    delete Reg;
}

void __fastcall TCheckBoxReg::MouseMove(TShiftState Shift, int X, int Y)
{
    int value;                 //reg value dword,binary
    System::AnsiString svalue; //reg value string
    System::AnsiString sText;  //Text to show in FEdit
    TFontStyles fns;
    TColor fcl;
    //if(bNeedShowText)
    TCheckBox::MouseMove(Shift,X,Y);
    if(FEdit!=NULL)
    {
    if(FCurrentCBR==this) //to avoid reEnter this routine, but not necessary
        return;

    switch(FRegRoot)
    {
        case HKLM:
             sText="\"HKEY_LOCAL_MACHINE"+this->FRegKeyName+"\\"+this->FRegValueName+"\"";
             break;
        case HKUS:
             sText="\"HKEY_USERS"+this->FRegKeyName+"\\"+this->FRegValueName+"\"";
             break;
        case HKCU:
             sText="\"HKEY_CURRENT_USER"+this->FRegKeyName+"\\"+this->FRegValueName+"\"";
             break;
        case HKCL:
             sText="\"HKEY_CLASS_ROOTS"+this->FRegKeyName+"\\"+this->FRegValueName+"\"";
             break;
    }

    switch(FRegType)
    {
        case B_INARY:
             value=(this->Checked)?FRegDW_checked:FRegDW_unchecked;
             sText=sText+","+IntToStr(value)+","+"\"REG_BINARY\"";
             break;
        case D_WORD:
             value=(this->Checked)?FRegDW_checked:FRegDW_unchecked;
             sText=sText+","+IntToStr(value)+","+"\"REG_DWORD\"";
             break;
        case S_TRING:
             svalue=(this->Checked)?FRegSTR_checked:FRegSTR_unchecked;
             sText=sText+",\""+svalue+"\","+"\"REG_SZ\"";
             break;
    }
    FEdit->Text=sText;
    //FEdit->Align=alNone;
    //FEdit->Width=340;
    }

    if(FCurrentCBR!=NULL)
    {
        fns=FCurrentCBR->Font->Style;
        fcl=FCurrentCBR->FColor;
        fns>>fsUnderline;
        FCurrentCBR->Font->Style=fns;
        FCurrentCBR->Font->Color=fcl;
    }
    fns=this->Font->Style;
    this->FColor=this->Font->Color;
    fns<<fsUnderline;
    this->Font->Style=fns;
    this->Font->Color=clBlue;
    FCurrentCBR=this;

}

void __fastcall TCheckBoxReg::SetFriend(TRegSpeedButton* fs1,TRegSpeedButton* fs2,TRichEdit* fe)
{
    if(fs1!=NULL)
        FSButton1=fs1;
    if(fs2!=NULL)
        FSButton2=fs2;
    if(fe!=NULL)
        FEdit=fe;
}

