//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CheckBoxReg"
#pragma link "EditReg"
#pragma link "RegSpeedButton"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------


void __fastcall TForm1::FormCreate(TObject *Sender)
{
    int i;
    TTreeNodes *pItems;
    TTreeNode  *pNode,*pSubNode;
    Form1->Caption=Application->Title;
    Form1->Icon=Application->Icon;
    TPageControl1->Top=-3;
    TPageControl1->Left=-3;
    TPageControl1->Width+=6;
    TPageControl1->Height+=6;
    Panel1->Height-=23;

    for(i=0;i<TPageControl1->PageCount;i++)
    {
        TPageControl1->Pages[i]->TabVisible=FALSE;
    }
    //Borland C builder's item editor can not specify the Data property
    //So I use code instead of TreeNotes Editor --tianwei
    pItems=TreeView->Items;
    pNode=pItems->AddObject(NULL,"Windows",TabMain);pNode->ImageIndex=2;pNode->SelectedIndex=2;
    pSubNode=pItems->AddChildObject(pNode,"Start Menu",TabStartMenu);pSubNode->ImageIndex=0;pSubNode->SelectedIndex=1;
    pSubNode=pItems->AddObject(pSubNode,"Control Panel",TabControlPanel);pSubNode->ImageIndex=3;pSubNode->SelectedIndex=3;
    pSubNode=pItems->AddObject(pSubNode,"Desktop",TabDesktop);pSubNode->ImageIndex=4;pSubNode->SelectedIndex=4;
    pSubNode=pItems->AddObject(pSubNode,"System 1",TabSystem1);pSubNode->ImageIndex=5;pSubNode->SelectedIndex=5;
    pSubNode=pItems->AddObject(pSubNode,"System 2",TabSystem2);pSubNode->ImageIndex=5;pSubNode->SelectedIndex=5;
    pSubNode=pItems->AddObject(pSubNode,"IE Options 1",TabIEOptions1);pSubNode->ImageIndex=6;pSubNode->SelectedIndex=6;
    pSubNode=pItems->AddObject(pSubNode,"IE Options 2",TabIEOptions2);pSubNode->ImageIndex=12;pSubNode->SelectedIndex=12;
    pSubNode=pItems->AddObject(pSubNode,"Network",TabNetwork);pSubNode->ImageIndex=7;pSubNode->SelectedIndex=7;
    pSubNode=pItems->AddObject(pSubNode,"Media",TabMedia);pSubNode->ImageIndex=11;pSubNode->SelectedIndex=11;
    pSubNode=pItems->AddObject(pSubNode,"Security",TabSec);pSubNode->ImageIndex=0;pSubNode->SelectedIndex=1;

    pNode=pItems->AddObject(pNode,"About",TabAbout);pNode->ImageIndex=10;pNode->SelectedIndex=10;
    pItems->Item[0]->Expand(FALSE);

    TEditReg::SetFriend(SButtonOK,SButtonApply,Edittext);
    TCheckBoxReg::SetFriend(SButtonOK,SButtonApply,Edittext);

    Application->ShowHint=TRUE;
    Application->HintPause=200;
    Application->HintHidePause=10000;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::TreeViewChange(TObject *Sender, TTreeNode *Node)
{
    if(Node->Data!=NULL)
        TPageControl1->ActivePage=(TTabSheet *)Node->Data;
    if(TPageControl1->ActivePage==TabMain ||TPageControl1->ActivePage==TabAbout)
        Edittext->Visible=false;
    else
        Edittext->Visible=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SButtonApplyClick(TObject *Sender)
{
    int i;
    for(i=0;i<Form1->ComponentCount;i++)
    {
        if(Form1->Components[i]->ClassNameIs("TCheckBoxReg"))
        {
           ((TCheckBoxReg*)(Form1->Components[i]))->SetRegValue();
        }
        if(Form1->Components[i]->ClassNameIs("TEditReg"))
        {
           ((TEditReg*)(Form1->Components[i]))->SetRegValue();
        }
    }
    SButtonApply->Enabled=false;
    SButtonOK->Enabled=false;
    SButtonApply->SetCurrentCount(0);
    SButtonOK->SetCurrentCount(0);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::SButtonOKClick(TObject *Sender)
{
    SButtonApply->Click();
    SButtonQuit->Click();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SButtonQuitClick(TObject *Sender)
{
    Application->Terminate();
}
//---------------------------------------------------------------------------



void __fastcall TForm1::EdittextMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
    //TRichEdit* re=dynamic_cast<TRichEdit*>(Sender);
    //re->Width=660;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PopupMenu1Popup(TObject *Sender)
{
    TPopupMenu* pm=dynamic_cast<TPopupMenu*>(Sender);
    if(Edittext->SelLength==0)
        pm->Items->Items[0]->Enabled=false;
    else
        pm->Items->Items[0]->Enabled=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CopyToClipBoard1Click(TObject *Sender)
{
    Edittext->CopyToClipboard();

}
//---------------------------------------------------------------------------





void __fastcall TForm1::EditReg16MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
    ((TEditReg *)Sender)->Hint=
"0 - Send LM response and NTLM response; never use NTLMv2 session security\n\
1 - Use NTLMv2 session security if negotiated \n\
2 - Send NTLM response only\n\
3 - Send NTLMv2 response only\n\
4 - DC refuses LM responses\n\
5 - DC refuses LM and NTLM responses(accepts only NTLMv2)";

}
//---------------------------------------------------------------------------

void __fastcall TForm1::EditReg18MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
    ((TEditReg *)Sender)->Hint=
"Lower 26bits represent driver letter A-Z";

}
//---------------------------------------------------------------------------

void __fastcall TForm1::EditReg21MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
    ((TEditReg *)Sender)->Hint=
"0 - Allow NULL IPC Connection\n1 - Restrict[WinNT4]\n2 - Restrict[Win2000]";
}
//---------------------------------------------------------------------------



 