//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "RegSpeedButton.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TRegSpeedButton *)
{
    new TRegSpeedButton(NULL);
}
//---------------------------------------------------------------------------
__fastcall TRegSpeedButton::TRegSpeedButton(TComponent* Owner)
    : TSpeedButton(Owner)
{
}
//---------------------------------------------------------------------------
namespace Regspeedbutton
{
    void __fastcall PACKAGE Register()
    {
        TComponentClass classes[1] = {__classid(TRegSpeedButton)};
        RegisterComponents("Samples", classes, 0);
    }
}
//---------------------------------------------------------------------------
int __fastcall TRegSpeedButton::GetCurrentCount(void)
{
    return FCurrentCount;
}
void __fastcall TRegSpeedButton::SetCurrentCount(int count)
{
    if (count>=0)
        FCurrentCount=count;
}
void __fastcall TRegSpeedButton::Increase(int acount)
{
    FCurrentCount+=acount;
    if(FCurrentCount<0)
        FCurrentCount=0;
}
void __fastcall TRegSpeedButton::EnableDisable(void)
{
    Enabled=(FCurrentCount>0)?true:false;
}
